#!/bin/bash
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 12 january 2014
#
# where you have store the script and the awk-program
DIR="<installation directory>/CodingStyle"
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
if [ -d ${WHERE} ] ;
then
  # Is a directory
  if [ -r ${WHERE} ] ;
  then
    if [ -a ".no_coding_style" ] ;
    then
      #echo "Datei .no_coding_file gefunden"
      exit
    fi
    if [ -a ".no_recursion" ] ;
    then
      foo= 0;
      # do not explore the next directory(ies)
    else
      cd ${WHERE}
      liste=`ls -1A`
      for file_1 in ${liste}
      do
        ${nameOfTheScript} ${file_1}
      done
      cd ..
    fi
  fi
else
  if [ ! -f ${WHERE} ] ;
  then
    echo "no such file "${WHERE}
    exit
  fi
  # Is a file
  do_it="no"
  base_1=`basename ${WHERE} .h`
  if [ ${base_1} != ${WHERE} ] ;
  then
    do_it="yes"
  fi
  base_1=`basename ${WHERE} .cpp`
  if [ ${base_1} != ${WHERE} ] ;
  then
    do_it="yes"
  fi
  if [ ${do_it} == "yes" ] ;
  then
    gawk -f ${DIR}/Comments.awk          < ${WHERE} > ${WHERE}.withoutComment
    gawk -f ${DIR}/One-Line-If-check.awk < ${WHERE}.withoutComment > coding-style-One-Line-If.tmp
    if [ -s coding-style-One-Line-If.tmp ] ;
    then
      echo "check the file "`pwd`/${WHERE}
      cat coding-style-One-Line-If.tmp
    fi
    rm coding-style-One-Line-If.tmp
    rm ${WHERE}.withoutComment
  fi
fi
